import wave
import audioop

class WavComposer:
    def __init__(self, sample_rate, channels=2, sample_width=2):
        self.sample_rate = sample_rate
        self.channels = channels
        self.sample_width = sample_width

    def compose(self, save_path, audio_bytes):
        with wave.open(save_path, 'wb') as wav_file:
            wav_file.setnchannels(self.channels) # Stereo audio
            wav_file.setsampwidth(self.sample_width) # 16-bit audio
            wav_file.setframerate(self.sample_rate) # Sample rate
        
            #left_channel = audioop.tomono(audio_bytes, 2, 1, 0)
            #right_channel = audioop.tomono(audio_bytes, 2, 0, 1)

            audio_bytes = audioop.mul(audio_bytes, 2, 40)

            #left_rms = audioop.rms(left_channel, 2)
            #right_rms = audioop.rms(right_channel, 2)

            #print(f"Left channel RMS: {left_rms}", file=sys.stderr)
            #print(f"Right channel RMS: {right_rms}", file=sys.stderr)
            #print('left' if left_rms > right_rms else 'right', file=sys.stderr)

            wav_file.writeframesraw(audio_bytes)

    def remove_initial_segment(self, audio_bytes, ms):
        bytes_per_sample = self.sample_width * self.channels
        num_samples_to_remove = int((ms / 1000.0) * self.sample_rate)
        bytes_to_remove = num_samples_to_remove * bytes_per_sample
        return audio_bytes[bytes_to_remove:]